var load = require('../io/net').loadRequest,
	Url = require('url');


exports.load = function(url, callback)
{


	//	<link rel="alternate" type="application/rss+xml" title="Engadget" href="http://www.engadget.com/rss.xml" />
	load(url, function(buffer)
	{
		if(!buffer) return callback('could not load feed');
		
		//test to see if it's HTML
		var links = buffer.match(/<link .*?>/g),
			urls  = [];

		if(links)
		{
			for(var i = links.length; i--;)
			{
				var link = links[i];
				if(link.search(/application\/(atom|rss)\+xml/) > -1)
				{
					var feed = link.match(/href=["'](.*?)["']/);
					if(feed)
					{       

						var feedUrl = feed[1];    
						                       

						//some urls don't have the domain specified, so we need to do that >.>    
						if(feedUrl.indexOf('://') == -1)
						{
							var parts = Url.parse(url);  
							feedUrl = 'http://'+parts.hostname+feedUrl;
						}                                            
						

						urls.push({url:feedUrl});      
					}
				}
			}   
			                
			if(urls.length) return callback(false, urls);
			
			return callback(url+ ' Does not have an RSS/Atom feed.');
		}


		//test to see if it's rss/atom

		if(buffer.indexOf('<rss') > -1 || (buffer.indexOf('<feed') > -1))
		{
			return callback(false, urls);
		}

		return callback(false);
	});
}
